#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <openssl/e_os2.h>
#include <openssl/buffer.h>
#include <openssl/crypto.h>
#include <openssl/objects.h>


#define SN_commonName                   "CN"
#define LN_commonName                   "commonName"
#define NID_commonName                  13

int main(int argc, char *argv[])
	{
	char *p, *q = 0, *program;

	p = strrchr(argv[0], '/');
	if (!p) p = strrchr(argv[0], '\\');
#ifdef OPENSSL_SYS_VMS
	if (!p) p = strrchr(argv[0], ']');
	if (p) q = strrchr(p, '>');
	if (q) p = q;
	if (!p) p = strrchr(argv[0], ':');
	q = 0;
#endif
	if (p) p++;
	if (!p) p = argv[0];
	if (p) q = strchr(p, '.');
	if (p && !q) q = p + strlen(p);

	if (!p)
		program = BUF_strdup("(unknown)");
	else
		{
		program = OPENSSL_malloc((q - p) + 1);
		strncpy(program, p, q - p);
		program[q - p] = '\0';
		}

	for(p = program; *p; p++)
		if (islower((unsigned char)(*p)))
			*p = toupper((unsigned char)(*p));

	q = strstr(program, "TEST");
	if (q > p && q[-1] == '_') q--;
	*q = '\0';
	ASN1_OBJECT *o;
 	o = OBJ_nid2obj(NID_commonName);

	if (OBJ_obj2nid(o) != NID_commonName){
		printf("Objects creation error !");
		return 1;
	   }

	int new_nid;
   	ASN1_OBJECT *obj;
	new_nid = OBJ_create("1.2.3.4", "NewOID", "New Object Identifier");
	obj = OBJ_nid2obj(new_nid);
        if (new_nid!= OBJ_obj2nid(obj)){
                printf("Objects initialization error !");
                return 1;
	}
	

	OPENSSL_free(program);
	return(0);
	}
