#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <openssl/e_os2.h>
#include <openssl/buffer.h>
#include <openssl/crypto.h>
#include <openssl/stack.h>


int cmp(const void *aa, const void *bb){
	int a=*(int*)aa;
	int b=*(int*)bb;
	if (a>b) return 1 ;
	else if (a==b) return 0;
	else return -1;	
}

int main(int argc, char *argv[])
	{
	char *p, *q = 0, *program;

	p = strrchr(argv[0], '/');
	if (!p) p = strrchr(argv[0], '\\');
#ifdef OPENSSL_SYS_VMS
	if (!p) p = strrchr(argv[0], ']');
	if (p) q = strrchr(p, '>');
	if (q) p = q;
	if (!p) p = strrchr(argv[0], ':');
	q = 0;
#endif
	if (p) p++;
	if (!p) p = argv[0];
	if (p) q = strchr(p, '.');
	if (p && !q) q = p + strlen(p);

	if (!p)
		program = BUF_strdup("(unknown)");
	else
		{
		program = OPENSSL_malloc((q - p) + 1);
		strncpy(program, p, q - p);
		program[q - p] = '\0';
		}

	for(p = program; *p; p++)
		if (islower((unsigned char)(*p)))
			*p = toupper((unsigned char)(*p));

	q = strstr(program, "TEST");
	if (q > p && q[-1] == '_') q--;
	*q = '\0';

	_STACK * stack;
	stack=sk_new(cmp);
	if (!stack){
		printf("stack creation error!");
		return 1;
	}
	sk_push(stack,(void*)2);
	int pos=sk_find(stack,(void*)2);
	printf("Position %i\n",pos);
	if (pos<0){
		printf("stack push error!");
		return 1;
	}
	sk_free(stack);
	OPENSSL_free(program);
	return(0);
	}
